/* Open Source License

Copyright 2005 by Frank McCown
All rights reserved.

Developed by:  Frank McCown
               Old Dominion University
               http://www.cs.odu.edu/~fmccown

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal with the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

         - Redistributions of source code must retain the above copyright
           notice, this list of conditions and the following disclaimers.
         - Redistributions in binary form must reproduce the above copyright
           notice, this list of conditions and the following disclaimers in the
           documentation and/or other materials provided with the distribution.
         - Neither the names of Open Archives Initiative Metadata Harvesting
           Project, Old Dominion University, nor the names of
           its contributors may be used to endorse or promote products derived
           from this Software without specific prior written permission.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS WITH THE SOFTWARE.

*/

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace oaidemo
{
	/// <summary>
	/// Summary description for metadata_oai_dc.
	/// </summary>
	public class metadata_oai_dc : System.Web.UI.Page
	{
		protected string dcRec = null;


		/// <summary>
		/// Create a DC record for the given identifier.
		/// </summary>
		private void ShowRecord()
		{
			DataSet ds = (DataSet)Application["RecordsDataSet"];

			System.Text.StringBuilder str = new System.Text.StringBuilder();

			// Get current row of DataTable that we want to display in DC format
			DataRow row = (DataRow) Session["Row"];

			string recordId = row["record_Id"].ToString();

			// Title
			str.Append("<dc:title>" + HttpUtility.HtmlEncode(row["title"].ToString()) + "</dc:title>\n");

			// Creator
			DataRow[] rows = ds.Tables["creator"].Select("record_Id='" + recordId + "'");
			foreach (DataRow r in rows)
			{
				str.Append("<dc:creator>" + HttpUtility.HtmlEncode(r["creator_Text"].ToString()) + "</dc:creator>\n"); 
			}
			
			// Subject
			rows = ds.Tables["subject"].Select("record_Id='" + recordId + "'");
			foreach (DataRow r in rows)
			{
				str.Append("<dc:subject>" + HttpUtility.HtmlEncode(r["subject_Text"].ToString()) + "</dc:subject>\n"); 
			}

			// Description
			rows = ds.Tables["description"].Select("record_Id='" + recordId + "'");
			foreach (DataRow r in rows)
			{
				str.Append("<dc:description>" + HttpUtility.HtmlEncode(r["description_Text"].ToString()) + "</dc:description>\n"); 
			}

			// Publisher
			str.Append("<dc:publisher>" + HttpUtility.HtmlEncode(row["publisher"].ToString()) + "</dc:publisher>\n"); 

			// Contributor 
			// No mapping for this DataSet

			// Date
			str.Append("<dc:date>" + HttpUtility.HtmlEncode(row["date"].ToString()) + "</dc:date>\n"); 

			// Type
			rows = ds.Tables["type"].Select("record_Id='" + recordId + "'");
			foreach (DataRow r in rows)
			{
				str.Append("<dc:type>" + HttpUtility.HtmlEncode(r["type_Text"].ToString()) + "</dc:type>\n"); 
			}

			// Format
			// No mapping for this DataSet

			// Identifier
			str.Append("<dc:identifier>" + row["link"] + "</dc:identifier>\n"); 

			// Source
			// No mapping for this DataSet

			// Language
			rows = ds.Tables["language"].Select("record_Id='" + recordId + "'");
			foreach (DataRow r in rows)
			{
				str.Append("<dc:language>" + HttpUtility.HtmlEncode(r["language_Text"].ToString()) + "</dc:language>\n"); 
			}

			// Relation
			// No mapping for this DataSet

			// Coverage
			rows = ds.Tables["coverage"].Select("record_Id='" + recordId + "'");
			foreach (DataRow r in rows)
			{
				str.Append("<dc:coverage>" + HttpUtility.HtmlEncode(r["coverage_Text"].ToString()) + "</dc:coverage>\n"); 
			}

			// Rights
			// No mapping for this DataSet
			

			dcRec = str.ToString();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);

			ShowRecord();
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    

		}
		#endregion
	}
}
